Index: palm/trunk/UTIL/chemistry/gasphase_preproc/mechanisms/def_simplep/chem_gasphase_mod.f90
===================================================================
--- palm/trunk/UTIL/chemistry/gasphase_preproc/mechanisms/def_simplep/chem_gasphase_mod.f90	(revision 3606)
+++ palm/trunk/UTIL/chemistry/gasphase_preproc/mechanisms/def_simplep/chem_gasphase_mod.f90	(revision 3639)
@@ -113,6 +113,6 @@
 ! 
 ! File                 : chem_gasphase_mod_Parameters.f90
-! Time                 : Fri Dec  7 12:47:15 2018
-! Working directory    : /home/forkel-r/palmstuff/work/trunk20181206/UTIL/chemistry/gasphase_preproc/tmp_kpp4palm
+! Time                 : Thu Dec 20 14:57:53 2018
+! Working directory    : /home/forkel-r/palmstuff/work/trunk20181220/UTIL/chemistry/gasphase_preproc/tmp_kpp4palm
 ! Equation file        : chem_gasphase_mod.kpp
 ! Output root filename : chem_gasphase_mod
@@ -126,5 +126,5 @@
 
 ! NSPEC - Number of chemical species
-  INTEGER, PARAMETER :: nspec = 12 
+  INTEGER, PARAMETER :: nspec = 11 
 ! NVAR - Number of Variable species
   INTEGER, PARAMETER :: nvar = 10 
@@ -132,5 +132,5 @@
   INTEGER, PARAMETER :: nvaract = 8 
 ! NFIX - Number of Fixed species
-  INTEGER, PARAMETER :: nfix = 2 
+  INTEGER, PARAMETER :: nfix = 1 
 ! NREACT - Number of reactions
   INTEGER, PARAMETER :: nreact = 8 
@@ -170,5 +170,4 @@
 
   INTEGER, PARAMETER, PUBLIC :: ind_h2o = 11 
-  INTEGER, PARAMETER, PUBLIC :: ind_o2 = 12 
 
 ! Index declaration for fixed species in FIX
@@ -176,5 +175,4 @@
 
   INTEGER, PARAMETER :: indf_h2o = 1 
-  INTEGER, PARAMETER :: indf_o2 = 2 
 
 ! NJVRP - Length of sparse Jacobian JVRP
@@ -200,6 +198,6 @@
 ! 
 ! File                 : chem_gasphase_mod_Global.f90
-! Time                 : Fri Dec  7 12:47:15 2018
-! Working directory    : /home/forkel-r/palmstuff/work/trunk20181206/UTIL/chemistry/gasphase_preproc/tmp_kpp4palm
+! Time                 : Thu Dec 20 14:57:53 2018
+! Working directory    : /home/forkel-r/palmstuff/work/trunk20181220/UTIL/chemistry/gasphase_preproc/tmp_kpp4palm
 ! Equation file        : chem_gasphase_mod.kpp
 ! Output root filename : chem_gasphase_mod
@@ -267,6 +265,6 @@
 ! 
 ! File                 : chem_gasphase_mod_JacobianSP.f90
-! Time                 : Fri Dec  7 12:47:15 2018
-! Working directory    : /home/forkel-r/palmstuff/work/trunk20181206/UTIL/chemistry/gasphase_preproc/tmp_kpp4palm
+! Time                 : Thu Dec 20 14:57:53 2018
+! Working directory    : /home/forkel-r/palmstuff/work/trunk20181220/UTIL/chemistry/gasphase_preproc/tmp_kpp4palm
 ! Equation file        : chem_gasphase_mod.kpp
 ! Output root filename : chem_gasphase_mod
@@ -317,6 +315,6 @@
 ! 
 ! File                 : chem_gasphase_mod_Monitor.f90
-! Time                 : Fri Dec  7 12:47:15 2018
-! Working directory    : /home/forkel-r/palmstuff/work/trunk20181206/UTIL/chemistry/gasphase_preproc/tmp_kpp4palm
+! Time                 : Thu Dec 20 14:57:53 2018
+! Working directory    : /home/forkel-r/palmstuff/work/trunk20181220/UTIL/chemistry/gasphase_preproc/tmp_kpp4palm
 ! Equation file        : chem_gasphase_mod.kpp
 ! Output root filename : chem_gasphase_mod
@@ -328,13 +326,13 @@
 
 
-  CHARACTER(len=15), PARAMETER, DIMENSION(12):: spc_names =  (/ &
+  CHARACTER(len=15), PARAMETER, DIMENSION(11):: spc_names =  (/ &
      'PM10           ','HNO3           ','RCHO           ',&
      'RH             ','HO2            ','O3             ',&
      'OH             ','RO2            ','NO             ',&
-     'NO2            ','H2O            ','O2             ' /)
+     'NO2            ','H2O            ' /)
 
   CHARACTER(len=100), PARAMETER, DIMENSION(8):: eqn_names =  (/ &
      '     NO2 --> O3 + NO                                                                                ',&
-     '      O3 --> 2 OH + O2                                                                              ',&
+     'O3 + H2O --> 2 OH                                                                                   ',&
      ' O3 + NO --> NO2                                                                                    ',&
      ' RH + OH --> RO2 + H2O                                                                              ',&
@@ -387,6 +385,6 @@
 ! 
 ! File                 : chem_gasphase_mod_Initialize.f90
-! Time                 : Fri Dec  7 12:47:15 2018
-! Working directory    : /home/forkel-r/palmstuff/work/trunk20181206/UTIL/chemistry/gasphase_preproc/tmp_kpp4palm
+! Time                 : Thu Dec 20 14:57:53 2018
+! Working directory    : /home/forkel-r/palmstuff/work/trunk20181220/UTIL/chemistry/gasphase_preproc/tmp_kpp4palm
 ! Equation file        : chem_gasphase_mod.kpp
 ! Output root filename : chem_gasphase_mod
@@ -413,6 +411,6 @@
 ! 
 ! File                 : chem_gasphase_mod_Integrator.f90
-! Time                 : Fri Dec  7 12:47:15 2018
-! Working directory    : /home/forkel-r/palmstuff/work/trunk20181206/UTIL/chemistry/gasphase_preproc/tmp_kpp4palm
+! Time                 : Thu Dec 20 14:57:53 2018
+! Working directory    : /home/forkel-r/palmstuff/work/trunk20181220/UTIL/chemistry/gasphase_preproc/tmp_kpp4palm
 ! Equation file        : chem_gasphase_mod.kpp
 ! Output root filename : chem_gasphase_mod
@@ -471,6 +469,6 @@
 ! 
 ! File                 : chem_gasphase_mod_LinearAlgebra.f90
-! Time                 : Fri Dec  7 12:47:15 2018
-! Working directory    : /home/forkel-r/palmstuff/work/trunk20181206/UTIL/chemistry/gasphase_preproc/tmp_kpp4palm
+! Time                 : Thu Dec 20 14:57:53 2018
+! Working directory    : /home/forkel-r/palmstuff/work/trunk20181220/UTIL/chemistry/gasphase_preproc/tmp_kpp4palm
 ! Equation file        : chem_gasphase_mod.kpp
 ! Output root filename : chem_gasphase_mod
@@ -498,6 +496,6 @@
 ! 
 ! File                 : chem_gasphase_mod_Jacobian.f90
-! Time                 : Fri Dec  7 12:47:15 2018
-! Working directory    : /home/forkel-r/palmstuff/work/trunk20181206/UTIL/chemistry/gasphase_preproc/tmp_kpp4palm
+! Time                 : Thu Dec 20 14:57:53 2018
+! Working directory    : /home/forkel-r/palmstuff/work/trunk20181220/UTIL/chemistry/gasphase_preproc/tmp_kpp4palm
 ! Equation file        : chem_gasphase_mod.kpp
 ! Output root filename : chem_gasphase_mod
@@ -525,6 +523,6 @@
 ! 
 ! File                 : chem_gasphase_mod_Function.f90
-! Time                 : Fri Dec  7 12:47:15 2018
-! Working directory    : /home/forkel-r/palmstuff/work/trunk20181206/UTIL/chemistry/gasphase_preproc/tmp_kpp4palm
+! Time                 : Thu Dec 20 14:57:53 2018
+! Working directory    : /home/forkel-r/palmstuff/work/trunk20181220/UTIL/chemistry/gasphase_preproc/tmp_kpp4palm
 ! Equation file        : chem_gasphase_mod.kpp
 ! Output root filename : chem_gasphase_mod
@@ -554,6 +552,6 @@
 ! 
 ! File                 : chem_gasphase_mod_Rates.f90
-! Time                 : Fri Dec  7 12:47:15 2018
-! Working directory    : /home/forkel-r/palmstuff/work/trunk20181206/UTIL/chemistry/gasphase_preproc/tmp_kpp4palm
+! Time                 : Thu Dec 20 14:57:53 2018
+! Working directory    : /home/forkel-r/palmstuff/work/trunk20181220/UTIL/chemistry/gasphase_preproc/tmp_kpp4palm
 ! Equation file        : chem_gasphase_mod.kpp
 ! Output root filename : chem_gasphase_mod
@@ -580,6 +578,6 @@
 ! 
 ! File                 : chem_gasphase_mod_Util.f90
-! Time                 : Fri Dec  7 12:47:15 2018
-! Working directory    : /home/forkel-r/palmstuff/work/trunk20181206/UTIL/chemistry/gasphase_preproc/tmp_kpp4palm
+! Time                 : Thu Dec 20 14:57:53 2018
+! Working directory    : /home/forkel-r/palmstuff/work/trunk20181220/UTIL/chemistry/gasphase_preproc/tmp_kpp4palm
 ! Equation file        : chem_gasphase_mod.kpp
 ! Output root filename : chem_gasphase_mod
@@ -791,5 +789,5 @@
 ! Computation of equation rates
   a(1) = rct(1) * v(10)
-  a(2) = rct(2) * v(6)
+  a(2) = rct(2) * v(6) * f(1)
   a(3) = rct(3) * v(6) * v(9)
   a(4) = rct(4) * v(4) * v(7)
@@ -850,32 +848,32 @@
 ! Local variables
 ! B - Temporary array
-  REAL(kind=dp):: b(13)
+  REAL(kind=dp):: b(14)
 
 ! B(1) = dA(1)/dV(10)
   b(1) = rct(1)
 ! B(2) = dA(2)/dV(6)
-  b(2) = rct(2)
-! B(3) = dA(3)/dV(6)
-  b(3) = rct(3) * v(9)
-! B(4) = dA(3)/dV(9)
-  b(4) = rct(3) * v(6)
-! B(5) = dA(4)/dV(4)
-  b(5) = rct(4) * v(7)
-! B(6) = dA(4)/dV(7)
-  b(6) = rct(4) * v(4)
-! B(7) = dA(5)/dV(8)
-  b(7) = rct(5) * v(9)
-! B(8) = dA(5)/dV(9)
-  b(8) = rct(5) * v(8)
-! B(9) = dA(6)/dV(5)
-  b(9) = rct(6) * v(9)
-! B(10) = dA(6)/dV(9)
-  b(10) = rct(6) * v(5)
-! B(11) = dA(7)/dV(7)
-  b(11) = rct(7) * v(10)
-! B(12) = dA(7)/dV(10)
-  b(12) = rct(7) * v(7)
-! B(13) = dA(8)/dV(1)
-  b(13) = rct(8)
+  b(2) = rct(2) * f(1)
+! B(4) = dA(3)/dV(6)
+  b(4) = rct(3) * v(9)
+! B(5) = dA(3)/dV(9)
+  b(5) = rct(3) * v(6)
+! B(6) = dA(4)/dV(4)
+  b(6) = rct(4) * v(7)
+! B(7) = dA(4)/dV(7)
+  b(7) = rct(4) * v(4)
+! B(8) = dA(5)/dV(8)
+  b(8) = rct(5) * v(9)
+! B(9) = dA(5)/dV(9)
+  b(9) = rct(5) * v(8)
+! B(10) = dA(6)/dV(5)
+  b(10) = rct(6) * v(9)
+! B(11) = dA(6)/dV(9)
+  b(11) = rct(6) * v(5)
+! B(12) = dA(7)/dV(7)
+  b(12) = rct(7) * v(10)
+! B(13) = dA(7)/dV(10)
+  b(13) = rct(7) * v(7)
+! B(14) = dA(8)/dV(1)
+  b(14) = rct(8)
 
 ! Construct the Jacobian terms from B's
@@ -885,75 +883,75 @@
   jvs(2) = 0
 ! JVS(3) = Jac_FULL(2,7)
-  jvs(3) = b(11)
+  jvs(3) = b(12)
 ! JVS(4) = Jac_FULL(2,10)
-  jvs(4) = b(12)
+  jvs(4) = b(13)
 ! JVS(5) = Jac_FULL(3,3)
   jvs(5) = 0
 ! JVS(6) = Jac_FULL(3,8)
-  jvs(6) = b(7)
+  jvs(6) = b(8)
 ! JVS(7) = Jac_FULL(3,9)
-  jvs(7) = b(8)
+  jvs(7) = b(9)
 ! JVS(8) = Jac_FULL(4,4)
-  jvs(8) = - b(5)
+  jvs(8) = - b(6)
 ! JVS(9) = Jac_FULL(4,7)
-  jvs(9) = - b(6)
+  jvs(9) = - b(7)
 ! JVS(10) = Jac_FULL(5,5)
-  jvs(10) = - b(9)
+  jvs(10) = - b(10)
 ! JVS(11) = Jac_FULL(5,8)
-  jvs(11) = b(7)
+  jvs(11) = b(8)
 ! JVS(12) = Jac_FULL(5,9)
-  jvs(12) = b(8) - b(10)
+  jvs(12) = b(9) - b(11)
 ! JVS(13) = Jac_FULL(6,6)
-  jvs(13) = - b(2) - b(3)
+  jvs(13) = - b(2) - b(4)
 ! JVS(14) = Jac_FULL(6,9)
-  jvs(14) = - b(4)
+  jvs(14) = - b(5)
 ! JVS(15) = Jac_FULL(6,10)
   jvs(15) = b(1)
 ! JVS(16) = Jac_FULL(7,4)
-  jvs(16) = - b(5)
+  jvs(16) = - b(6)
 ! JVS(17) = Jac_FULL(7,5)
-  jvs(17) = b(9)
+  jvs(17) = b(10)
 ! JVS(18) = Jac_FULL(7,6)
   jvs(18) = 2* b(2)
 ! JVS(19) = Jac_FULL(7,7)
-  jvs(19) = - b(6) - b(11)
+  jvs(19) = - b(7) - b(12)
 ! JVS(20) = Jac_FULL(7,8)
   jvs(20) = 0
 ! JVS(21) = Jac_FULL(7,9)
-  jvs(21) = b(10)
+  jvs(21) = b(11)
 ! JVS(22) = Jac_FULL(7,10)
-  jvs(22) = - b(12)
+  jvs(22) = - b(13)
 ! JVS(23) = Jac_FULL(8,4)
-  jvs(23) = b(5)
+  jvs(23) = b(6)
 ! JVS(24) = Jac_FULL(8,7)
-  jvs(24) = b(6)
+  jvs(24) = b(7)
 ! JVS(25) = Jac_FULL(8,8)
-  jvs(25) = - b(7)
+  jvs(25) = - b(8)
 ! JVS(26) = Jac_FULL(8,9)
-  jvs(26) = - b(8)
+  jvs(26) = - b(9)
 ! JVS(27) = Jac_FULL(8,10)
   jvs(27) = 0
 ! JVS(28) = Jac_FULL(9,5)
-  jvs(28) = - b(9)
+  jvs(28) = - b(10)
 ! JVS(29) = Jac_FULL(9,6)
-  jvs(29) = - b(3)
+  jvs(29) = - b(4)
 ! JVS(30) = Jac_FULL(9,8)
-  jvs(30) = - b(7)
+  jvs(30) = - b(8)
 ! JVS(31) = Jac_FULL(9,9)
-  jvs(31) = - b(4) - b(8) - b(10)
+  jvs(31) = - b(5) - b(9) - b(11)
 ! JVS(32) = Jac_FULL(9,10)
   jvs(32) = b(1)
 ! JVS(33) = Jac_FULL(10,5)
-  jvs(33) = b(9)
+  jvs(33) = b(10)
 ! JVS(34) = Jac_FULL(10,6)
-  jvs(34) = b(3)
+  jvs(34) = b(4)
 ! JVS(35) = Jac_FULL(10,7)
-  jvs(35) = - b(11)
+  jvs(35) = - b(12)
 ! JVS(36) = Jac_FULL(10,8)
-  jvs(36) = b(7)
+  jvs(36) = b(8)
 ! JVS(37) = Jac_FULL(10,9)
-  jvs(37) = b(4) + b(8) + b(10)
+  jvs(37) = b(5) + b(9) + b(11)
 ! JVS(38) = Jac_FULL(10,10)
-  jvs(38) = - b(1) - b(12)
+  jvs(38) = - b(1) - b(13)
       
 END SUBROUTINE jac_sp
@@ -983,5 +981,5 @@
 
   rconst(1) = (phot(j_no2))
-  rconst(2) = (phot(j_o31d) * 0.1_dp)
+  rconst(2) = (2.0_dp * 2.2e-10_dp * phot(j_o31d) / (arr2(1.9e+8_dp , -390.0_dp , temp)))
   rconst(3) = (arr2(1.8e-12_dp , 1370.0_dp , temp))
   rconst(4) = (arr2(2.e-11_dp , 500.0_dp , temp))